/*
 * find.c
 * Copyright (C) LenaD 2010 <lenad89@list.ru>
 * 
 */
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <malloc.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/stat.h>
#include <dirent.h>
#include <fnmatch.h>
#include <libgen.h>
extern void *xmalloc(size_t size);
extern char *xstrcpy(char *in);
extern void passgdir(char *ppath);
extern void mreaddir(DIR *dir,char *currpath);
extern char *NAME;
extern char *PATH;
extern int isHOME;
extern int isNAME;
void *
xmalloc(size_t size)
{
	void *tmp=malloc(size);
	if (tmp==NULL) {		
		fprintf(stderr,"не удалось выделить память :"
		        "%s\n",strerror(errno));
		exit(1);		
	}
	memset(tmp,0,size);
	return tmp;	
}

char *
xstrcpy(char *in)
{
	char* tmp=(char *)xmalloc(strlen(in)+1);
	strcpy(tmp,in);	
	return tmp;
}

void correct(char* fname,int *iscorr)
{
	if (isNAME) {
		char *bname=basename(fname);	
		int ismatch=fnmatch(NAME,bname,0);
		if (ismatch==FNM_NOMATCH) {
			*iscorr=0;
		} else if (ismatch!=0) {
			fprintf(stderr,"неверный шаблон"
			        "%s\n",strerror(errno));
			exit(1);
		}
	}
}

void push(char* name)
{
	if (isHOME)
		printf(".%s\n",name+strlen(PATH));
	else
		printf("%s\n",name);
}

void 
openderr(int sterr,char *fname)
{
	fprintf(stderr,"не удалось открыть каталог"
	        "%s :%s\n",fname,strerror(sterr));
};
void staterror(int sterr,char *fname)
{
	fprintf(stderr,"не удалось получить stat у файла"
	        "%s :%s\n",fname,strerror(sterr));	 
};

void
passgdir(char *ppath)
{
	DIR* dir;
	struct stat pst;
	int isadd=1;
	if (lstat(ppath,&pst)==-1) {
		staterror(errno,ppath);
	} else {		
		correct(ppath,&isadd);
		if (isadd)
			push(ppath);
		if (S_ISDIR(pst.st_mode)) {
			if ((dir=opendir(ppath))!=NULL) {
				mreaddir(dir,ppath);
				closedir(dir);
			} else
				openderr(errno,ppath);		
		}
	}
}
void
mreaddir(DIR *dir,char *currpath)
{
	struct dirent *currfile;
	char * fullname;
	size_t sizep=strlen(currpath);
	while ((currfile=readdir(dir))!=NULL) {
		fullname=(char *)xmalloc(strlen(currfile->d_name)+sizep+2);
		if (currpath[sizep-1]!='/')
			sprintf(fullname, "%s/%s",currpath,currfile->d_name);
		else
			sprintf(fullname, "%s%s\0",currpath,currfile->d_name);
		if ((strcoll(currfile->d_name,".") && strcoll(currfile->d_name,".."))) {
			passgdir(fullname);
		}		
		free(fullname);			
	}
}

char *
xgetcwd(void)
{
	char *tmp=NULL;
	if ((tmp=getcwd(tmp,0))==NULL) {
		fprintf(stderr,"не удалось получить имя текущего каталога"
		        "%s\n",strerror(errno));
		exit(1);
	}
	return tmp;
}
char *NAME;
char *PATH;
int isHOME;
int isNAME;

int
main(int argc,char** argv)
{
	if (argv[1]!=NULL){
		PATH=xstrcpy(argv[1]);
	} else {
		PATH=xgetcwd();
		isHOME=1;
	}
	
	if (argv[2]!=NULL) {
		NAME=xstrcpy(argv[2]);
		isNAME=1;
	}
	passgdir(PATH);
	free(PATH);
	free(NAME);
	return 0;
};
